unit TTFDumper;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Menus, Buttons, ComCtrls,Shellapi,
  TTFDumperOption;

type TOffsetTable = record
       sfntVersionInt     : Word;
       sfntVersionFrac    : Word;
       numTables          : Word;
       searchRange        : Word;
       entrySelector      : Word;
       rangeShift         : Word;
     end;

type TTableDirectoryEntry = record
       tag                : ARRAY[0..3] of char; {ULONG}
       checkSum           : LongInt; {ULONG}
       offset             : LongInt; {ULONG}
       length             : LongInt; {ULONG}
     end;

type TNameTable = record
       wFormatSelector      : Word;
       wNumNameRecords      : Word;
       wOffsetStringStorage : Word;
     end;

type TNameRecord = record
       wPlatformID          : Word;
       wPlatformencodingID  : Word;
       wLanguageID          : Word;
       wNameID              : Word;
       wStringLen           : Word;
       wStringOffset        : Word;
     end;

type TPanose = record
       bFamilyType          : Byte;
       bSerifStyle          : Byte;
       bWeight              : Byte;
       bProportion          : Byte;
       bContrast            : Byte;
       bStrokeVariation     : Byte;
       bArmStyle            : Byte;
       bLetterForm          : Byte;
       bMidline             : Byte;
       bXHeight             : Byte;
     end;

type TOS2Table = record
       wVersion             : Word;
       ixAvgCharWidth       : SmallInt;
       wWeightClass         : Word;
       wWidthClass          : Word;
       ifsType              : SmallInt;
       iySubscriptXSize     : SmallInt;
       iySubscriptYSize     : SmallInt;
       iySubscriptXOffset   : SmallInt;
       iySubscriptYOffset   : SmallInt;
       iySuperScriptXSize   : SmallInt;
       iySuperScriptYSize   : SmallInt;
       iySuperScriptXOffset : SmallInt;
       iySuperScriptYOffset : SmallInt;
       iyStrikeoutSize      : SmallInt;
       iyStrikeoutPosition  : SmallInt;
       isFamilyClass        : SmallInt;
       Panose               : TPanose;
       wUR1                 : Word;
       wUR2                 : Word;
       wUR3                 : Word;
       wUR4                 : Word;
       wUR5                 : Word;
       wUR6                 : Word;
       wUR7                 : Word;
       wUR8                 : Word;
{       ulUnicodeRange1      : longint;
       ulUnicodeRange2      : longint;
       ulUnicodeRange3      : longint;
       ulUnicodeRange4      : longint;}
       achVendID            : ARRAY [1..4] of char;
       ifsSelection         : SmallInt;
       wFirstCharIndex      : Word;
       wLastCharIndex       : Word;
       wsTypoAscender       : Word;
       wsTypoDescender      : Word;
       wsTypoLineGap        : Word;
       wWinAscent           : Word;
       wWinDescent          : Word;
       wCPR1                : Word;
       wCPR2                : Word;
       wCPR3                : Word;
       wCPR4                : Word;
{       ulCodePageRange1     : longint;
       ulCodePageRange2     : longint;}
     end;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Edition1: TMenuItem;
    Polices1: TMenuItem;
    Aide1: TMenuItem;
    Quitter1: TMenuItem;
    Annuler1: TMenuItem;
    N1: TMenuItem;
    Couper1: TMenuItem;
    Copier1: TMenuItem;
    Coller1: TMenuItem;
    Charger1: TMenuItem;
    Sommaire1: TMenuItem;
    Index1: TMenuItem;
    Apropos1: TMenuItem;
    DriveComboBox1: TDriveComboBox;
    RepSource: TDirectoryListBox;
    GroupBox1: TGroupBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    StatusBar1: TStatusBar;
    NameSortie: TEdit;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    Installer1: TMenuItem;
    Dsinstaller1: TMenuItem;
    Copier2: TMenuItem;
    Voir1: TMenuItem;
    Rcuperer1: TMenuItem;
    Metrixdata1: TMenuItem;
    headFontHeaderData1: TMenuItem;
    hheaHorizontalHeaderData1: TMenuItem;
    vheaVerticalHeaderData1: TMenuItem;
    maxpMaxProfileData1: TMenuItem;
    nameNamingData1: TMenuItem;
    OS2Windowsmetricdata1: TMenuItem;
    Autrestables1: TMenuItem;
    Options1: TMenuItem;
    SpeedButton2: TSpeedButton;
    BitBtn4: TBitBtn;
    SaveDialog1: TSaveDialog;
    procedure Traite;
    procedure BitBtn1Click(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure Sommaire1Click(Sender: TObject);
    procedure Index1Click(Sender: TObject);
    procedure Metrixdata1Click(Sender: TObject);
    procedure headFontHeaderData1Click(Sender: TObject);
    procedure hheaHorizontalHeaderData1Click(Sender: TObject);
    procedure vheaVerticalHeaderData1Click(Sender: TObject);
    procedure maxpMaxProfileData1Click(Sender: TObject);
    procedure nameNamingData1Click(Sender: TObject);
    procedure OS2Windowsmetricdata1Click(Sender: TObject);
    procedure Autrestables1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var FirstChange : Boolean = True;
var TTFRep : ARRAY [0..1024] of char;
const TempDir = 'C:\Windows\Temp';
const TempFOT = TempDir + '\TempFOT.FOT';

var
  Form1: TForm1;

implementation

uses TTFDumperOptions;

{$R *.DFM}

procedure swW (var data : word);
begin
 data := swap (data);
end;

procedure swI (var data : SmallInt);
begin
 data := swap (data);
end;

procedure swL (var data : longint);
type swLdata = ARRAY [0..3] of byte;
var p : ^swLdata;
begin
 p := @data;
 data := (p[0] shl 24) + (p[1] shl 16) + (p[2] shl 8) + p[3];
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var tmp : ARRAY [0..1024] of char;
begin
 StrPCopy (tmp,ExtractFilePath (Application.ExeName));
 StrCat (tmp,'\TTFDumper.html');
 ShellExecute (0,NIL,tmp,NIL,NIL,SW_SHOWNORMAL)
end;

{$I-}
procedure TForm1.Traite;
var fout : TextFile;
var TTfile : TSearchRec;
var TTFName : String;
var PTTFName : array [0..256] of char;
var code : integer;
var myfont : HFONT;
var myDC : HDC;
var mytm : TTEXTMETRIC;
var StrTemp,StrTemp2 : string; {array[0..256] of char;}
var IORes : Integer;
{ Partie ProceedTTFFile }
var TTF : file of char;
var OffsetTable : TOffsetTable;
var CurTableDirectoryEntry : TTableDirectoryEntry;
var NameTable : TNameTable;
var OS2Table : TOS2Table;
var NameRecord,Nom,Style,Id,Version : TNameRecord;
var i,j : Integer;
var Buf : ARRAY [1..8192] of char;

{ Parties Offset }
var save_offset : longint;
var name_offset : longint;
var os2_offset : longint;

procedure writebin (n : word);
var i : integer;
begin
 For i := 15 downto 0 do
  Begin
   if (n AND (1 shl i)) <> 0 Then write (fout,'1') else write (fout,'0');
  End;
end;

begin
 { Cration du fichier }
 If fileexists (NameSortie.Text) Then
  Begin
   If (Application.MessageBox ('Le fichier spcifi existe dja.'#10#13'Ecraser le fichier existant ?','Fichier existant', MB_YESNO+MB_ICONQUESTION) <> IDYES) Then Exit
  End;

 StatusBar1.SimpleText := 'Dbut de l''exploration.';
 AssignFile (fout,NameSortie.Text);
 Rewrite (fout);
 { Parcours du rpertoire }
 Writeln (fout,'Exploration du rpertoire : ',RepSource.Directory);
 Write (fout,'Nom Fichier|');
 { Enregistrement des noms des champs }
 Write (fout,'Taille|');
 Write (fout,'Date|');
 Write (fout,'Nom|');
 Write (fout,'Style|');
 Write (fout,'ID|');
 Write (fout,'Version|');
 Write (fout,'OS2Version|');
 Write (fout,'xAvgCharWidth|');
 Write (fout,'usWeightClass|');
 Write (fout,'usWidthClass|');
 Write (fout,'fsType|');
 Write (fout,'ySubScriptXSize|');
 Write (fout,'ySubScriptYSize|');
 Write (fout,'ySubScriptXOffset|');
 Write (fout,'ySubScriptYOffset|');
 Write (fout,'ySuperScriptXSize|');
 Write (fout,'ySuperScriptYSize|');
 Write (fout,'ySuperScriptXOffset|');
 Write (fout,'ySuperScriptYOffset|');
 Write (fout,'yStrikeOutSize|');
 Write (fout,'yStrikeOutPosition|');
 Write (fout,'sFamilyClass-Class|');
 Write (fout,'sFamilyClass-SubClass|');
 Write (fout,'bFamilyType|');
 Write (fout,'bSerifStyle|');
 Write (fout,'bWeight|');
 Write (fout,'bProportion|');
 Write (fout,'bContrast|');
 Write (fout,'bStrokeVariation|');
 Write (fout,'bArmStyle|');
 Write (fout,'bLetterForm|');
 Write (fout,'bMidline|');
 Write (fout,'bXHeight|');
 Write (fout,'ulUnicodeRange1|');
 Write (fout,'ulUnicodeRange2|');
 Write (fout,'ulUnicodeRange3|');
 Write (fout,'ulUnicodeRange4|');
 Write (fout,'achVenID|');
 Write (fout,'fsSelection|');
 Write (fout,'usFirstCharIndex|');
 Write (fout,'usLastCharIndex|');
 Write (fout,'sTypoAscender|');
 Write (fout,'sTypoDecender|');
 Write (fout,'sTypoLineGap|');
 Write (fout,'usWinAscent|');
 Write (fout,'usWinDescent|');
 Write (fout,'ulCodePageRange1|');
 Write (fout,'ulCodePageRange2|');
 Writeln (fout);

 code := FindFirst(RepSource.Directory+'\*.ttf',faAnyFile,TTFile);
 while (code=0) do
  Begin
   { Rcuperation des infos }
   Write (fout,TTfile.name,'|');
   { Pour rcuperer le nom... }
   TTFName := RepSource.Directory+'\'+TTfile.name;

{ Inclusion module ProceedTTFFile }
 { Ouverture du fichier }
 AssignFile (TTF, TTFName);
 Reset (TTF);
 IORes := IOResult;
 If (IORes <> 0) Then
  Begin
   Str(IOResult,StrTemp);
   Write (fout,'Erreur lors de l''ouverture du fichier : Erreur N',IORes,'|');
   {StrPCopy (StrTemp2,TTFName);}
   {Application.MessageBox ('Erreur lors de l''ouverture du fichier '#10#13+ #10#13'Erreur N','Erreur',MB_ICONHAND+MB_OK);}
  End;
 {Writeln (fout,'Traitement de ',TTFName);}
 { Lecture de l'offset Table }
 {Writeln (fout,' Taille du fichier : ',FileSize (TTF)) ;}
 Write (fout,FileSize (TTF),'|');
 Write (fout,DateToStr (FileDateToDateTime(TTFile.Time)),'|');
 Flush (fout);
 BlockRead (TTF, OffsetTable, 12);
 { Enregistrement de Offset Table }
 {Writeln (fout, '  OffsetTable');}
 swW(OffsetTable.sfntVersionInt); swW(OffsetTable.sfntVersionFrac); {Writeln (fout, #9'Version : ',OffsetTable.sfntVersionInt,'.',OffsetTable.sfntVersionFrac);}
 swW(OffsetTable.numTables); {Writeln (fout, #9'numTables : ',OffsetTable.numTables);}
 swW(OffsetTable.searchRange); {Writeln (fout, #9'searchRange : ',OffsetTable.searchRange);}
 swW(OffsetTable.entrySelector); {Writeln (fout, #9'entrySelector : ',OffsetTable.entrySelector);}
 swW(OffsetTable.rangeShift); {Writeln (fout, #9'rangeShift : ',OffsetTable.rangeShift);}
 {Writeln (fout);}
 { Lecture des Entries }
 os2_offset := -1;
 name_offset := -1;
 For i := 1 To OffsetTable.numTables do
  Begin
   BlockRead (TTF,CurTableDirectoryEntry,sizeof (TTableDirectoryEntry));
   {Write (fout, i);}
   {Write (fout, #9, CurTableDirectoryEntry.tag);}
   swL(CurTableDirectoryEntry.checkSum); {Write (fout, #9'chk ', CurTableDirectoryEntry.checkSum);}
   swL(CurTableDirectoryEntry.offset); {Write (fout, #9'off ',CurTableDirectoryEntry.offset);}
   swL(CurTableDirectoryEntry.length); {Write (fout, #9'len ',CurTableDirectoryEntry.length);}
   {Writeln (fout);}
   {Traitements spcifiques}
   if (CurTableDirectoryEntry.tag = 'name') then begin name_offset := CurTableDirectoryEntry.offset; end;
   if (CurTableDirectoryEntry.tag = 'OS/2') then begin os2_offset := CurTableDirectoryEntry.offset; end;
  End;
  { Lecture de 'name' }
  {Writeln (fout);}
  {Writeln (fout,'Analyse de ''name''');}
  If (name_offset <> -1) Then
   Begin
    Nom.wNameId := 0;
    Style.wNameID := 0;
    ID.wNameID := 0;
    Version.wNameID := 0;
    Seek (TTF,name_offset);
    BlockRead (TTF,NameTable,sizeof(TNameTable));
    swW (NameTable.wFormatSelector); {Writeln (fout,#9'Format Selector : ',NameTable.wFormatSelector);}
    swW (NameTable.wNumNameRecords); {Writeln (fout,#9'NumNamesRecords : ',NameTable.wNumNameRecords);}
    swW (NameTable.wOffsetStringStorage); {Writeln (fout, #9'Offset String Storage : ',NameTable.wOffsetStringStorage);}
    For i:=1 To NameTable.wNumNameRecords do
     Begin
      BlockRead (TTF,NameRecord,sizeof(TNameRecord));
  {    Write (fout,i,#9);}
      swW (NameRecord.wPlatformID); {Write (fout, #9'',NameRecord.wPlatformID);}
      swW (NameRecord.wPlatformencodingID); {Write (fout, #9'',NameRecord.wPlatformencodingID);}
      swW (NameRecord.wLanguageID); {Write (fout, #9'',NameRecord.wLanguageID);}
      swW (NameRecord.wNameID); {Write (fout, #9'',NameRecord.wNameID);}
      swW (NameRecord.wStringLen); {Write (fout, #9'',NameRecord.wStringLen);}
      swW (NameRecord.wStringOffset); {Write (fout, #9'',NameRecord.wStringOffset);}

      If (NameRecord.wNameID = 5) Then
       Begin
        If (Version.wNameID = 0 ) Then  Version:= NameRecord
           Else
          Begin
           If (NameRecord.wPlatformID = 3) AND (NameRecord.wPlatformencodingID = 1) Then
            Begin
             If (Version.wPlatformID <> 3) Then Version := NameRecord;
             If (NameRecord.wLanguageID = 1036) Then Version:= NameRecord;
             If (NameRecord.wLanguageID = 1033) AND (Version.wLanguageID <> 1036) Then Version:= NameRecord;
            End;
           If (NameRecord.wPlatformID = 1) AND (Version.wPlatformID <> 3) Then Version:= NameRecord;
           If (NameRecord.wPlatformID = 0) AND (Version.wPlatFormID <> 1) AND (Version.wPlatformID <> 3) Then Version:=NameRecord;
          End;
       End;
      If (NameRecord.wNameID = 3) Then
       Begin
        If (ID.wNameID = 0 ) Then  ID:= NameRecord
           Else
          Begin
           If (NameRecord.wPlatformID = 3) AND (NameRecord.wPlatformencodingID = 1) Then
            Begin
             If (ID.wPlatformID <> 3) Then ID := NameRecord;
             If (NameRecord.wLanguageID = 1036) Then ID:= NameRecord;
             If (NameRecord.wLanguageID = 1033) AND (ID.wLanguageID <> 1036) Then ID:= NameRecord;
            End;
           If (NameRecord.wPlatformID = 1) AND (ID.wPlatformID <> 3) Then ID:= NameRecord;
           If (NameRecord.wPlatformID = 0) AND (ID.wPlatFormID <> 1) AND (ID.wPlatformID <> 3) Then ID:=NameRecord;
          End;
       End;
      If (NameRecord.wNameID = 1) Then
       Begin
        If (Nom.wNameID = 0 ) Then  Nom := NameRecord
           Else
          Begin
           If (NameRecord.wPlatformID = 3) AND (NameRecord.wPlatformencodingID = 1) Then
            Begin
             If (Nom.wPlatformID <> 3) Then Nom := NameRecord;
             If (NameRecord.wLanguageID = 1036) Then Nom:= NameRecord;
             If (NameRecord.wLanguageID = 1033) AND (Nom.wLanguageID <> 1036) Then Nom:= NameRecord;
            End;
           If (NameRecord.wPlatformID = 1) AND (Nom.wPlatformID <> 3) Then Nom := NameRecord;
           If (NameRecord.wPlatformID = 0) AND (Nom.wPlatFormID <> 1) AND (Nom.wPlatformID <> 3) Then Nom:=NameRecord;
          End;
       End;
      If (NameRecord.wNameID = 2) Then
       Begin
        If (Style.wNameID = 0 ) Then  Style:= NameRecord
           Else
          Begin
           If (NameRecord.wPlatformID = 3) AND (NameRecord.wPlatformencodingID = 1) Then
            Begin
             If (Style.wPlatformID <> 3) Then Style := NameRecord;
             If (NameRecord.wLanguageID = 1036) Then Style:= NameRecord;
             If (NameRecord.wLanguageID = 1033) AND (Style.wLanguageID <> 1036) Then Style:= NameRecord;
            End;
           If (NameRecord.wPlatformID = 1) AND (Style.wPlatformID <> 3) Then Style:= NameRecord;
           If (NameRecord.wPlatformID = 0) AND (Style.wPlatFormID <> 1) AND (Style.wPlatformID <> 3) Then Style:=NameRecord;
          End;
       End;
      {
      save_offset := FilePos (TTF);
      Seek (TTF,name_offset+NameTable.wOffsetStringStorage+NameRecord.wStringOffset);
      Flush (fout);
      BlockRead (TTF,Buf,NameRecord.wStringLen);
      Write (fout,#9);
      For j:=1 to NameRecord.wStringLen do If (Buf[j] <> #10) and (Buf[j]<> #13) Then Write(fout,Buf[j]) else Write (fout,'\');
      Seek (TTF,save_offset);
      }
      {Writeln (fout);}
     End;
    {Ecriture des champs selectionnes }
     {Writeln(fout,'Selection des champs');}
     {Nom}
      If ((Nom.wNameID=0)) Then Write (fout,'ND|') Else
       Begin
        {Write (fout, 'Nom :');}
        NameRecord := Nom;
        save_offset := FilePos (TTF);
        Seek (TTF,name_offset+NameTable.wOffsetStringStorage+NameRecord.wStringOffset);
        Flush (fout);
        BlockRead (TTF,Buf,NameRecord.wStringLen);
        {Write (fout,#9);}
        For j:=1 to NameRecord.wStringLen do If (Buf[j] <> #10) and (Buf[j]<> #13) Then Write(fout,Buf[j]) else Write (fout,'\');
        Seek (TTF,save_offset);
        Write (fout,'|');
       End;
     {Style}
      If ((Style.wNameID=0)) Then Write (fout,'ND|') Else
       Begin
        {Write (fout, 'Style :');}
        NameRecord := Style;
        save_offset := FilePos (TTF);
        Seek (TTF,name_offset+NameTable.wOffsetStringStorage+NameRecord.wStringOffset);
        Flush (fout);
        BlockRead (TTF,Buf,NameRecord.wStringLen);
        {Write (fout,#9);}
        For j:=1 to NameRecord.wStringLen do If (Buf[j] <> #10) and (Buf[j]<> #13) Then Write(fout,Buf[j]) else Write (fout,'\');
        Seek (TTF,save_offset);
        Write (fout,'|');
       End;
     {ID}
      If ((ID.wNameID=0)) Then Write (fout,'ND|') Else
       Begin
       {Write (fout, 'ID :');}
        NameRecord := ID;
        save_offset := FilePos (TTF);
        Seek (TTF,name_offset+NameTable.wOffsetStringStorage+NameRecord.wStringOffset);
        Flush (fout);
        BlockRead (TTF,Buf,NameRecord.wStringLen);
        {Write (fout,#9);}
        For j:=1 to NameRecord.wStringLen do If (Buf[j] <> #10) and (Buf[j]<> #13) Then Write(fout,Buf[j]) else Write (fout,'\');
        Seek (TTF,save_offset);
        Write (fout,'|');
       End;
     {Version}
      If ((Version.wNameID=0)) Then Write (fout,'ND|') Else
       Begin
        {Write (fout, 'Version :');}
        NameRecord := Version;
        save_offset := FilePos (TTF);
        Seek (TTF,name_offset+NameTable.wOffsetStringStorage+NameRecord.wStringOffset);
        Flush (fout);
        BlockRead (TTF,Buf,NameRecord.wStringLen);
        {Write (fout,#9);}
        For j:=1 to NameRecord.wStringLen do If (Buf[j] <> #10) and (Buf[j]<> #13) Then Write(fout,Buf[j]) else Write (fout,'\');
        Seek (TTF,save_offset);
        Write (fout,'|');
       End;
    End
     else
    Begin
      Write (fout,'Name Table Missing !!!!!||||');
    End;
  { Lecture de 'os/2' }
  If (os2_offset <> -1) Then
   Begin
    {Writeln (fout);}
    {Writeln (fout, 'Analyse de ''Os/2''');}
    Seek (TTF,os2_offset);
    {$I-}
    BlockRead (TTF,OS2Table,sizeof (TOS2Table));
    {$I+}
{    BlockRead (TTF,OS2Table,78); }
    swW (OS2Table.wVersion); Write (fout,OS2Table.wVersion,'|');
    swI (OS2Table.ixAvgCharWidth); Write (fout,OS2Table.ixAvgCharWidth,'|');
    swW (OS2Table.wWeightClass); Write (fout,OS2Table.wWeightClass,'|');
    swW (OS2Table.wWidthClass); Write (fout,OS2Table.wWidthClass,'|');
    swI (OS2Table.ifsType); Write (fout,OS2Table.ifsType,'|');
    swI (OS2Table.iySubscriptXSize); Write (fout,OS2Table.iySubscriptXSize,'|');
    swI (OS2Table.iySubscriptYSize); Write (fout,OS2Table.iySubscriptYSize,'|');
    swI (OS2Table.iySubscriptXOffset); Write (fout,OS2Table.iySubscriptXOffset,'|');
    swI (OS2Table.iySubscriptYOffset); Write (fout,OS2Table.iySubscriptYOffset,'|');
    swI (OS2Table.iySuperScriptXSize); Write (fout,OS2Table.iySuperScriptXSize,'|');
    swI (OS2Table.iySuperScriptYSize); Write (fout,OS2Table.iySuperScriptYSize,'|');
    swI (OS2Table.iySuperScriptXOffset); Write (fout,OS2Table.iySuperScriptXOffset,'|');
    swI (OS2Table.iySuperScriptYOffset); Write (fout,OS2Table.iySuperScriptYOffset,'|');
    swI (OS2Table.iyStrikeoutSize); Write (fout,OS2Table.iyStrikeoutSize,'|');
    swI (OS2Table.iyStrikeoutPosition); Write (fout,OS2Table.iyStrikeoutPosition,'|');
    swI (OS2Table.isFamilyClass); Write (fout,HiByte(Word(OS2Table.isFamilyClass)),'|'); Write (fout,LoByte(Word(OS2Table.isFamilyClass)),'|');
    Write (fout,OS2Table.Panose.bFamilyType,'|');
    Write (fout,OS2Table.Panose.bSerifStyle,'|');
    Write (fout,OS2Table.Panose.bWeight,'|');
    Write (fout,OS2Table.Panose.bProportion,'|');
    Write (fout,OS2Table.Panose.bContrast,'|');
    Write (fout,OS2Table.Panose.bStrokeVariation,'|');
    Write (fout,OS2Table.Panose.bArmStyle,'|');
    Write (fout,OS2Table.Panose.bLetterForm,'|');
    Write (fout,OS2Table.Panose.bMidline,'|');
    Write (fout,OS2Table.Panose.bXHeight,'|');
  {  swL (OS2Table.ulUnicodeRange1); Write (fout,OS2Table.ulUniCodeRange1,'|');}
    swW (OS2Table.wUR1); write(fout,''''); writebin (OS2Table.wUR1); Write (fout,'');
    swW (OS2Table.wUR2); writebin (OS2Table.wUR2); Write (fout,'|');
    swW (OS2Table.wUR3); write(fout,''''); writebin (OS2Table.wUR3); Write (fout,'');
    swW (OS2Table.wUR4); writebin (OS2Table.wUR4); Write (fout,'|');
    swW (OS2Table.wUR5); write(fout,''''); writebin (OS2Table.wUR5); Write (fout,'');
    swW (OS2Table.wUR6); writebin (OS2Table.wUR6); Write (fout,'|');
    swW (OS2Table.wUR7); write(fout,''''); writebin (OS2Table.wUR7); Write (fout,'');
    swW (OS2Table.wUR8); writebin (OS2Table.wUR8); Write (fout,'|');
  {  swL (OS2Table.ulUniCodeRange2); Write (fout,OS2Table.ulUniCodeRange2,'|');
    swL (OS2Table.ulUniCodeRange3); Write (fout,OS2Table.ulUniCodeRange3,'|');
    swL (OS2Table.ulUniCodeRange4); Write (fout,OS2Table.ulUniCodeRange4,'|');}
    Write (fout,OS2Table.achVendID,'|');
    swI (OS2Table.ifsSelection); Write (fout,OS2Table.ifsSelection,'|');
    swW (OS2Table.wFirstCharIndex); Write (fout,OS2Table.wFirstCharIndex,'|');
    swW (OS2Table.wLastCharIndex); Write (fout,OS2Table.wLastCharIndex,'|');
    swW (OS2Table.wsTypoAscender); Write (fout,smallint(OS2Table.wsTypoAscender),'|');
    swW (OS2Table.wsTypoDescender); Write (fout,smallint(OS2Table.wsTypoDescender),'|');
    swW (OS2Table.wsTypoLineGap); Write (fout,OS2Table.wsTypoLineGap,'|');
    swW (OS2Table.wWinAscent); Write (fout,smallint(OS2Table.wWinAscent),'|');
    swW (OS2Table.wWinDescent); Write (fout,smallint(OS2Table.wWinDescent),'|');
    swW (OS2Table.wCPR1); write(fout,''''); writebin (OS2Table.wCPR1); Write (fout,'');
    swW (OS2Table.wCPR2); writebin (OS2Table.wCPR2); Write (fout,'|');
    swW (OS2Table.wCPR3); write(fout,''''); writebin (OS2Table.wCPR3); Write (fout,'');
    swW (OS2Table.wCPR4); writebin (OS2Table.wCPR4); Write (fout,'|');

    {  swL (OS2Table.ulCodePageRange1); Write (fout,OS2Table.ulCodePageRange1,'|');
    swL (OS2Table.ulCodePageRange2); Write (fout,OS2Table.ulCodePageRange2,'|');}
  End
   else
  Begin
   Write (fout,'OS/2 Table Missing !!!!!');
  End;
 Writeln (fout);
 { Fermeture du fichier }
 CloseFile (TTF);

 {Fin du module ProceedTTFFile }
   { Enregistrement des infos }
   code:=FindNext (TTfile);
  End;
 { Fermeture du fichier }
 CloseFile (fout);
 StatusBar1.SimpleText := 'Fin de l''exploration.';
end;
{$I+}

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
 Traite;
end;

procedure TForm1.Apropos1Click(Sender: TObject);
begin
 Application.MessageBox('TTF Dumper'#10#13'Peyronnet Rmi - RP-Soft 99'#10#13#10#13'Analyseur de polices TTF'#10#13#10#13'Version Spciale.'#10#13'Utilisateur : Peyronnet Andr'#10#13'Bon Anniversaire 1999.',
                             'A Propos de TTF Dumper',MB_ICONINFORMATION+MB_OK);
end;

procedure TForm1.Sommaire1Click(Sender: TObject);
var tmp : ARRAY [0..1024] of char;
begin
 StrPCopy (tmp,ExtractFilePath (Application.ExeName));
 StrCat (tmp,'\TTFDumper.html');
 ShellExecute (0,NIL,tmp,NIL,NIL,SW_SHOWNORMAL)
end;

procedure TForm1.Index1Click(Sender: TObject);
var tmp : ARRAY [0..1024] of char;
begin
 StrPCopy (tmp,ExtractFilePath (Application.ExeName));
 StrCat (tmp,'\TTFDumper.html');
 ShellExecute (0,NIL,tmp,NIL,NIL,SW_SHOWNORMAL)
end;

procedure TForm1.Metrixdata1Click(Sender: TObject);
begin
 Traite;
end;

procedure TForm1.headFontHeaderData1Click(Sender: TObject);
begin
 Application.MessageBox ('Trs prochainement sur vos crans...'#10#13'Information accessible par ttfdump.','A venir...',MB_OK);
end;

procedure TForm1.hheaHorizontalHeaderData1Click(Sender: TObject);
begin
 Application.MessageBox ('Trs prochainement sur vos crans...'#10#13'Information accessible par ttfdump.','A venir...',MB_OK);

end;

procedure TForm1.vheaVerticalHeaderData1Click(Sender: TObject);
begin
 Application.MessageBox ('Trs prochainement sur vos crans...'#10#13'Information accessible par ttfdump.','A venir...',MB_OK);

end;

procedure TForm1.maxpMaxProfileData1Click(Sender: TObject);
begin
 Application.MessageBox ('Trs prochainement sur vos crans...'#10#13'Information accessible par ttfdump.','A venir...',MB_OK);

end;

procedure TForm1.nameNamingData1Click(Sender: TObject);
begin
 Application.MessageBox ('Trs prochainement sur vos crans...'#10#13'Information accessible par ttfdump.','A venir...',MB_OK);

end;

procedure TForm1.OS2Windowsmetricdata1Click(Sender: TObject);
begin
 Application.MessageBox ('Trs prochainement sur vos crans...'#10#13'Information accessible par ttfdump.','A venir...',MB_OK);

end;

procedure TForm1.Autrestables1Click(Sender: TObject);
begin
 Application.MessageBox ('Trs prochainement sur vos crans...'#10#13'Information accessible par ttfdump.','A venir...',MB_OK);

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  SaveDialog1.FileName:=NameSortie.Text;
  SaveDialog1.Execute;
  NameSortie.Text := SaveDialog1.FileName;
end;

procedure TForm1.Options1Click(Sender: TObject);
begin
 OptionsForm.ShowModal;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var tmp : ARRAY [0..1024] of char;
begin
 StrPCopy (tmp,NameSortie.Text);
 ShellExecute (0,NIL,tmp,NIL,NIL,SW_SHOWNORMAL)
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var tmp : ARRAY [0..1024] of char;
begin
 StrPCopy (tmp,ExtractFilePath (Application.ExeName));
 StrCat (tmp,'\ttch02.doc');
 ShellExecute (0,NIL,tmp,NIL,NIL,SW_SHOWNORMAL)
end;

end.
